
/*
 *  Copyright (c) 2015, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

function submitActivityForm(page, pageNumber) {
    sessionAwareFunction(function() {
        //Do the normal logic when the seesion is not timed out

        var reasonDiv = document.getElementById('activityReason');
        var reason = "";
        var searchResuts = $('activityList');
        searchResuts.innerHTML = org_wso2_carbon_registry_activities_ui_jsi18n["searching"];

        var fromDate = document.getElementById('fromDate');
        var toDate = document.getElementById('toDate');
        var userName = document.getElementById('user');
        var path = document.getElementById('path');
        var filterElement = document.getElementById('filter');
        var filter = filterElement.options[filterElement.selectedIndex].value;

        if (fromDate.value != "") reason += validateDate(fromDate, org_wso2_carbon_registry_activities_ui_jsi18n["from"]);
        if (toDate.value != "") reason += validateDate(toDate, org_wso2_carbon_registry_activities_ui_jsi18n["to"]);
        //validate the from and to date functions.
        reason += validateToFromDate(fromDate, toDate);
        if (userName.value != "") reason += validateForInput(userName, org_wso2_carbon_registry_activities_ui_jsi18n["username"]);
        if (path.value != "") reason += validateForInput(path, org_wso2_carbon_registry_activities_ui_jsi18n["path"]);


        var fromDateValue = fromDate.value;
        var toDateValue = toDate.value;
        var userNameValue = userName.value;
        var pathValue = path.value;



        if(fromDateValue!="" && (fromDateValue == toDateValue)){
            $('activityList').innerHTML="";
            CARBON.showWarningDialog(org_wso2_carbon_registry_activities_ui_jsi18n["from.date.equal.to.date"]);
            return true;
        }

        if(fromDateValue=="" && toDateValue=="" && userNameValue =="" && pathValue =="" && filter == "all"){
            $('activityList').innerHTML="";
            CARBON.showWarningDialog(org_wso2_carbon_registry_activities_ui_jsi18n["please.fill.at.least.one"]);
            return true;
        }
        reasonDiv.innerHTML = reason;
        if (reason != "") {
            CARBON.showWarningDialog(reason);
            $('activityList').innerHTML = "";
            return false;
        }
        else {

            var advancedSearchForm = $('activityForm');
            advancedSearchForm.style.display = "none";
            reasonDiv.innerHTML = "<a href=\"#\" " +
                                  "onclick=\"javascript:document.getElementById('activityForm').style.display='block';" +
                                  "this.parentNode.style.display='none'\"" +
                                  "class=\"icon-link\" style=\"background-image:url(images/search.gif);\">" +
                                  org_wso2_carbon_registry_activities_ui_jsi18n["search.again"] + "</a>";
            reasonDiv.style.display = "block";
            if (pageNumber) {
                new Ajax.Request('../activities/activity-ajaxprocessor.jsp',
                {
                    method:'post',
                    parameters: {fromDate: fromDateValue, toDate: toDateValue, userName:userNameValue,path:pathValue,filter:filter,page:page,requestedPage:pageNumber},

                    onSuccess: function(transport) {
                        $('activityList').innerHTML = transport.responseText;
                    },

                    onFailure: function(transport) {
                        CARBON.showErrorDialog(org_wso2_carbon_registry_activities_ui_jsi18n["an.error.occured"] +
                                               " " + transport.responseText);
                    }
                });
            } else {
                new Ajax.Request('../activities/activity-ajaxprocessor.jsp',
                {
                    method:'post',
                    parameters: {fromDate: fromDateValue, toDate: toDateValue, userName:userNameValue,path:pathValue,filter:filter,page:page},

                    onSuccess: function(transport) {
                        $('activityList').innerHTML = transport.responseText;
                    },

                    onFailure: function(transport) {
                        CARBON.showErrorDialog(org_wso2_carbon_registry_activities_ui_jsi18n["an.error.occured"] +
                                               " " + transport.responseText);
                    }
                });
            }
        }

    }, org_wso2_carbon_registry_activities_ui_jsi18n["session.timed.out"]);
}

/**
 * Method to send sort request to backend using Ajax call.
 *
 * @param pageNumber    current page of the search results
 * @param sortOrder     ascending or descending
 */
function sort(pageNumber, sortOrder) {
    sessionAwareFunction(function() {

        // Do the normal logic when the seesion is not timed out

        var searchResuts = $('activityList');
        searchResuts.innerHTML = org_wso2_carbon_registry_activities_ui_jsi18n["searching"];

        var fromDate = document.getElementById('fromDate');
        var toDate = document.getElementById('toDate');
        var userName = document.getElementById('user');
        var path = document.getElementById('path');
        var filterElement = document.getElementById('filter');
        var filter = filterElement.options[filterElement.selectedIndex].value;

        var fromDateValue = fromDate.value;
        var toDateValue = toDate.value;
        var userNameValue = userName.value;
        var pathValue = path.value;


        if (pageNumber) {
            new Ajax.Request('../activities/activity-ajaxprocessor.jsp',
            {
                method:'post',
                parameters: {fromDate: fromDateValue, toDate: toDateValue, userName:userNameValue,path:pathValue,filter:filter,requestedPage:pageNumber,sortOrder:sortOrder},

                onSuccess: function(transport) {
                    $('activityList').innerHTML = transport.responseText;
                },

                onFailure: function(transport) {
                    CARBON.showErrorDialog(org_wso2_carbon_registry_activities_ui_jsi18n["an.error.occured"] +
                                               " " + transport.responseText);
                }
            });
        } else {
            new Ajax.Request('../activities/activity-ajaxprocessor.jsp',
            {
                method:'post',
                parameters: {fromDate: fromDateValue, toDate: toDateValue, userName:userNameValue,path:pathValue,filter:filter,sortOrder:sortOrder},

                onSuccess: function(transport) {
                    $('activityList').innerHTML = transport.responseText;
                },

                onFailure: function(transport) {
                    CARBON.showErrorDialog(org_wso2_carbon_registry_activities_ui_jsi18n["an.error.occured"] +
                                               " " + transport.responseText);
                    }
            });
        }


    }, org_wso2_carbon_registry_activities_ui_jsi18n["session.timed.out"]);
}




function handleUserNameKeyPress(event) {
    if (event.keyCode == 13) {
        submitActivityForm(1);
    }
}

function clearAll(){
    var table = $('#_innerTable');
    var Inputrows = table.getElementsByTagName('input');

    for (var i = 0; i < Inputrows.length; i++) {
         if (Inputrows[i].type == "text") {
            Inputrows[i].value = "";
         }
    }
    var SelectAreas = table.getElementsByTagName('select');
    for (var i = 0; i < SelectAreas.length; i++) {
        SelectAreas[i].selectedIndex = 0;
    }
}